#ifndef _KGR_PATCH_BSC1097108_H
#define _KGR_PATCH_BSC1097108_H

#if IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM)

int kgr_patch_bsc1097108_init(void);
void kgr_patch_bsc1097108_cleanup(void);


struct x86_emulate_ctxt;
struct desc_ptr;

int kgr_em_lgdt(struct x86_emulate_ctxt *ctxt);
int kgr_em_lidt(struct x86_emulate_ctxt *ctxt);
int kgr_emulate_store_desc_ptr(struct x86_emulate_ctxt *ctxt,
			       void (*get)(struct x86_emulate_ctxt *ctxt,
					   struct desc_ptr *ptr));

#define KGR_PATCH_BSC1097108_FUNCS				\
	KGR_PATCH_OBJ(em_lgdt, kgr_em_lgdt, "kvm"),		\
	KGR_PATCH_OBJ(em_lidt, kgr_em_lidt, "kvm"),		\
	KGR_PATCH_OBJ(emulate_store_desc_ptr,			\
			kgr_emulate_store_desc_ptr, "kvm"),	\

#else /* !(IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM)) */

static inline int kgr_patch_bsc1097108_init(void) { return 0; }
static inline void kgr_patch_bsc1097108_cleanup(void) {}

#define KGR_PATCH_BSC1097108_FUNCS


#endif /* IS_ENABLED(CONFIG_X86_64) && IS_ENABLED(CONFIG_KVM) */

#endif /* _KGR_PATCH_BSC1097108 */
